    001/*
    002 * Copyright (c) 2016-2017 Daniel Ennis (Aikar) - MIT License
    003 *
    004 *  Permission is hereby granted, free of charge, to any person obtaining
    005 *  a copy of this software and associated documentation files (the
    006 *  "Software"), to deal in the Software without restriction, including
    007 *  without limitation the rights to use, copy, modify, merge, publish,
    008 *  distribute, sublicense, and/or sell copies of the Software, and to
    009 *  permit persons to whom the Software is furnished to do so, subject to
    010 *  the following conditions:
    011 *
    012 *  The above copyright notice and this permission notice shall be
    013 *  included in all copies or substantial portions of the Software.
    014 *
    015 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    016 *  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    017 *  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
    018 *  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
    019 *  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
    020 *  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
    021 *  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
    022 */
    023
    024package co.aikar.commands;
    025
    026import co.aikar.locales.MessageKey;
    027import org.bukkit.configuration.ConfigurationSection;
    028import org.bukkit.configuration.InvalidConfigurationException;
    029import org.bukkit.configuration.file.FileConfiguration;
    030import org.bukkit.configuration.file.YamlConfiguration;
    031
    032import java.io.File;
    033import java.io.IOException;
    034import java.util.Locale;
    035
    036public class BukkitLocales extends Locales {
    037    private final BukkitCommandManager manager;
    038
    039    public BukkitLocales(BukkitCommandManager manager) {
    040        super(manager);
    041        this.manager = manager;
    042        this.addBundleClassLoader(this.manager.getPlugin().getClass().getClassLoader());
    043    }
    044
    045    @Override
    046    public void loadLanguages() {
    047        super.loadLanguages();
    048        String pluginName = "acf-" + manager.plugin.getDescription().getName();
    049        addMessageBundles("acf-minecraft", pluginName, pluginName.toLowerCase());
    050    }
    051
    052    /**
    053     * Loads the given file
    054     * @param file
    055     * @param locale
    056     * @return If any language keys were added
    057     * @throws IOException
    058     * @throws InvalidConfigurationException
    059     */
    060    public boolean loadYamlLanguageFile(File file, Locale locale) throws IOException, InvalidConfigurationException {
    061        YamlConfiguration yamlConfiguration = new YamlConfiguration();
    062        yamlConfiguration.load(file);
    063        return loadLanguage(yamlConfiguration, locale);
    064    }
    065
    066    /**
    067     * Loads a file out of the plugins data folder by the given name
    068     * @param file
    069     * @param locale
    070     * @return If any language keys were added
    071     * @throws IOException
    072     * @throws InvalidConfigurationException
    073     */
    074    public boolean loadYamlLanguageFile(String file, Locale locale) throws IOException, InvalidConfigurationException {
    075        YamlConfiguration yamlConfiguration = new YamlConfiguration();
    076        yamlConfiguration.load(new File(this.manager.plugin.getDataFolder(), file));
    077        return loadLanguage(yamlConfiguration, locale);
    078    }
    079
    080    /**
    081     * Loads every message from the Configuration object. Any nested values will be treated as namespace
    082     * so acf-core:\n\tfoo: bar will be acf-core.foo = bar
    083     * @param config
    084     * @param locale
    085     * @return If any language keys were added
    086     */
    087    public boolean loadLanguage(FileConfiguration config, Locale locale) {
    088        boolean loaded = false;
    089        for (String parentKey : config.getKeys(false)) {
    090            ConfigurationSection inner = config.getConfigurationSection(parentKey);
    091            if (inner == null) {
    092                continue;
    093            }
    094            for (String key : inner.getKeys(false)) {
    095                String value = inner.getString(key);
    096                if (value != null && !value.isEmpty()) {
    097                    addMessage(locale, MessageKey.of(parentKey + "." + key), value);
    098                    loaded = true;
    099                }
    100            }
    101        }
    102
    103        return loaded;
    104    }
    105}